package com.bcxin.rbac.domain.services.commands.categories;

import com.bcxin.Infrastructures.commands.CommandAbstract;
import lombok.Getter;

import java.util.Collection;

@Getter
public class BatchCategoryResourceCommand extends CommandAbstract {
    private final Collection<CategoryCommand> categories;

    public BatchCategoryResourceCommand(Collection<CategoryCommand> categories) {
        this.categories = categories;
    }

    public static BatchCategoryResourceCommand create(Collection<CategoryCommand> categories) {
        return new BatchCategoryResourceCommand(categories);
    }

    @Getter
    public static class CategoryCommand extends CommandAbstract {
        private final String id;
        private final String name;
        private final Collection<CategoryResourceCommand> resources;

        public CategoryCommand(String id, String name, Collection<CategoryResourceCommand> resources) {
            this.id = id;
            this.name = name;
            this.resources = resources;
        }

        public static CategoryCommand create(String id, String name, Collection<CategoryResourceCommand> resources)
        {
            return new CategoryCommand(id,name,resources);
        }
    }

    @Getter
    public static class CategoryResourceCommand extends CommandAbstract {
        private final String id;
        private final String name;

        public CategoryResourceCommand(String id, String name) {
            this.id = id;
            this.name = name;
        }

        public static CategoryResourceCommand create(String id, String name) {
            return new CategoryResourceCommand(id, name);
        }
    }
}
